jQuery(function($) {

    <?php
    // setup debug and global variables.
    $envira_debug = ( defined( 'ENVIRA_DEBUG' ) && 'true' === ENVIRA_DEBUG ) ? $version = time() . '-' . ENVIRA_VERSION : ENVIRA_VERSION;
    ?>

    <?php if ( $envira_debug ) : ?>

    console.log('Module ID: <?php echo $id; ?>');
    console.log('Text: <?php echo $settings->envira_gallery_id;  ?>');

    <?php endif; ?>

    $( '.fl-node-<?php echo $id; ?>' ).find( '.envira-gallery-public').trigger('envira_load');

    var gallery_changed = false;

    var envira_gallery_id = $('#envira-bb-gallery-id').val();

    <?php if ( $envira_debug ) : ?>
    console.log( 'envira_gallery_id_g: ' + envira_gallery_id );
    console.log( 'window.envira_gallery_id: ' + window.envira_gallery_id );
    <?php endif; ?>

    // set global 'state'

    if ( ( window.envira_gallery_id === 'undefined' || window.envira_gallery_id === '' ) && envira_gallery_id !== 'undefined' ) {

        // this means that we went from nothing to a gallery

            // make the global gallery id hold the new one
            window.envira_gallery_id = envira_gallery_id;

            // change the state to 'new'
            gallery_changed = 'new';

            <?php if ( $envira_debug ) : ?>
            console.log( 'gallery_changed: ' + gallery_changed );
            <?php endif; ?>

    } else if ( envira_gallery_id !== 'undefined' && window.envira_gallery_id !== 'undefined' && window.envira_gallery_id !== envira_gallery_id ) {

        // this means that we are likely switching to another gallery id

            // make the global gallery id hold the new one
            window.envira_gallery_id = envira_gallery_id;

            // change the state to 'changed'
            gallery_changed = 'changed';

            <?php if ( $envira_debug ) : ?>
            console.log( 'gallery_changed: ' + gallery_changed );
            <?php endif; ?>

    } else if ( envira_gallery_id !== 'undefined' && window.envira_gallery_id !== 'undefined' && window.envira_gallery_id === envira_gallery_id ) {

        // this means that we haven't changed galleries, likely the user is changing a setting to modify the gallery.

            // change the state to 'changed'
            gallery_changed = 'not-changed';

            <?php if ( $envira_debug ) : ?>
            console.log( 'gallery_changed: ' + gallery_changed );
            <?php endif; ?>

    }


    if ( envira_gallery_id === '' || envira_gallery_id === 0 || envira_gallery_id === '0' ) {

        <?php if ( $envira_debug ) : ?>
        console.log('DISABLE');
        <?php endif; ?>

        // if there is no gallery selected, reset the dropdowns and disable everything since the fields shouldn't be used.

        $('.fl-builder-settings').find('select[name=gallery_layout]').val( $('.fl-builder-settings').find('select[name=gallery_layout] option:first').val() );
        $('.fl-builder-settings').find('select[name=gallery_columns]').val( $('.fl-builder-settings').find('select[name=gallery_columns] option:first').val() );
        $('.fl-builder-settings').find('select[name=lightbox_theme]').val( $('.fl-builder-settings').find('select[name=lightbox_theme] option:first').val() );

        $('.fl-builder-settings').find('select[name=gallery_layout]').prop("disabled", true);
        $('.fl-builder-settings').find('select[name=gallery_columns]').prop("disabled", true);
        $('.fl-builder-settings').find('select[name=gallery_margins]').prop("disabled", true);
        $('.fl-builder-settings').find('input[name=custom_margin]').prop("disabled", true);
        $('.fl-builder-settings').find('input[name=enable_lightbox]').prop("disabled", true);
        $('.fl-builder-settings').find('select[name=lightbox_theme]').prop("disabled", true);

    } else {

        <?php if ( $envira_debug ) : ?>
        console.log('NOT DISABLE');
        <?php endif; ?>

        // if there is a gallery, make sure the fields are not disabled.

        $('.fl-builder-settings').find('select[name=gallery_layout]').prop("disabled", false);
        $('.fl-builder-settings').find('select[name=gallery_columns]').prop("disabled", false);
        $('.fl-builder-settings').find('select[name=gallery_margins]').prop("disabled", false);
        $('.fl-builder-settings').find('input[name=custom_margin]').prop("disabled", false);
        $('.fl-builder-settings').find('input[name=enable_lightbox]').prop("disabled", false);
        $('.fl-builder-settings').find('select[name=lightbox_theme]').prop("disabled", false);
    }

    if ( gallery_changed === 'changed' ) {

        // if the gallery has been changed.

        var layout_g           = $('#envira-bb-layout').val();
        var columns_g          = $('#envira-bb-columns').val();
        var custom_margin_g    = $('#envira-bb-margin').val();
        var lightbox_enabled_g = ( $('#envira-bb-lightbox-theme').val() === 0 ) ? 0 : 1
        var lightbox_theme_g   = $('#envira-bb-lightbox-theme').val();

        <?php if ( $envira_debug ) : ?>
        console.log( 'Layout (Gallery): ' + layout_g );
        console.log( 'Columns (Gallery): ' + columns_g );
        console.log( 'Custom Margin (Gallery): ' + custom_margin_g );
        console.log( 'Lightbox Enabled (Gallery): ' + lightbox_enabled_g );
        console.log( 'Lightbox Theme (Gallery): ' + lightbox_theme_g );
        <?php endif; ?>

        window.envira_gallery_layout  = layout_g;
        window.envira_gallery_columns = columns_g;

        // if the layout of the incoming gallery is automatic, then don't display columns.

        if ( layout_g === 'automatic' ) {
            columns_g = '';
        }

        // Update the Beaver Builder UI based on the incoming gallery hidden fields.

        $('.fl-builder-settings').find('select[name=gallery_layout]').val( layout_g );
        $('.fl-builder-settings').find('select[name=gallery_columns]').val( columns_g );

        if ( custom_margin_g === 0 || custom_margin_g.length === 0 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 0 );
        } else if ( custom_margin_g === 5 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 5 );
        } else if ( custom_margin_g === 20 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 20 );
        } else if ( custom_margin_g === 1 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 1 );
        } else {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 'custom' );
        }

        $('.fl-builder-settings').find('input[name=custom_margin]').val( custom_margin_g );


        if ( lightbox_enabled_g === '1' ) {
            $('.fl-builder-settings').find('input[name=enable_lightbox]').prop('checked', true);
        } else {
            $('.fl-builder-settings').find('input[name=enable_lightbox').prop('checked', false);
        }

        if ( lightbox_theme_g.length > 0 ) {
            $('.fl-builder-settings').find('select[name=lightbox_theme]').val( lightbox_theme_g );
        } else {
            $('.fl-builder-settings').find('select[name=lightbox_theme]').val( '' );
            <?php if ( $envira_debug ) : ?>
            console.log(' reset lightbox theme dropdown ');
            <?php endif; ?>
        }

    } else if ( gallery_changed === 'new' ) {

        // going from nothing to a gallery is very similar to changing galleries.

        var layout_g           = $('#envira-bb-layout').val();
        var columns_g          = $('#envira-bb-columns').val();
        var custom_margin_g    = $('#envira-bb-margin').val();
        var lightbox_enabled_g = ( $('#envira-bb-lightbox-theme').val() === 0 ) ? 0 : 1;
        var lightbox_theme_g   = $('#envira-bb-lightbox-theme').val();

        <?php if ( $envira_debug ) : ?>
        console.log( 'Layout (Gallery): ' + layout_g );
        console.log( 'Columns (Gallery): ' + columns_g );
        console.log( 'Custom Margin (Gallery): ' + custom_margin_g );
        console.log( 'Lightbox Enabled (Gallery): ' + lightbox_enabled_g );
        console.log( 'Lightbox Theme (Gallery): ' + lightbox_theme_g );
        <?php endif; ?>

        window.envira_gallery_layout  = layout_g;
        window.envira_gallery_columns = columns_g;

        // if the layout of the incoming gallery is automatic, then don't display columns.

        if ( layout_g === 'automatic' ) {
            columns_g = '';
        }

        // Update the Beaver Builder UI based on the incoming gallery hidden fields.

        $('.fl-builder-settings').find('select[name=gallery_layout]').val( layout_g );
        $('.fl-builder-settings').find('select[name=gallery_columns]').val( columns_g );

        if ( custom_margin_g === 0 || custom_margin_g.length === 0 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 0 );
        } else if ( custom_margin_g === 5 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 5 );
        } else if ( custom_margin_g === 20 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 20 );
        } else if ( custom_margin_g === 1 ) {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 1 );
        } else {
            $('.fl-builder-settings').find('select[name=gallery_margins]').val( 'custom' );
        }

        $('.fl-builder-settings').find('input[name=custom_margin]').val( custom_margin_g );


        if ( lightbox_enabled_g === '1' ) {
            $('.fl-builder-settings').find('input[name=enable_lightbox]').prop('checked', true);
        } else {
            $('.fl-builder-settings').find('input[name=enable_lightbox').prop('checked', false);
        }

        if ( lightbox_theme_g.length > 0 ) {
            $('.fl-builder-settings').find('select[name=lightbox_theme]').val( lightbox_theme_g );
        } else {
            $('.fl-builder-settings').find('select[name=lightbox_theme]').val( 0 );
            <?php if ( $envira_debug ) : ?>
            console.log(' reset lightbox theme dropdown ');
            <?php endif; ?>
        }


    } else if ( gallery_changed === 'not-changed' ) {

        // if the gallery has not been changed (perhaps a single setting in the UI was triggered)

        // Compare the values from the incoming gallery to those global and determine what has changed?

        var layout_g           = $('#envira-bb-layout').val();
        var columns_g          = $('#envira-bb-columns').val();
        var custom_margin_g    = $('#envira-bb-margin').val();
        var lightbox_enabled_g = ( $('#envira-bb-lightbox-theme').val() === 0 ) ? 0 : 1;
        var lightbox_theme_g   = $('#envira-bb-lightbox-theme').val();

        var layout_b  = $('.fl-builder-settings').find('select[name=gallery_layout]').val();
        var columns_b = $('.fl-builder-settings').find('select[name=gallery_columns]').val();

        <?php if ( $envira_debug ) : ?>
        console.log( 'gallery settings: layout is ' + layout_g + ' and columns is ' + columns_g );
        console.log( 'dropdown settings: layout is ' + layout_b + ' and columns is ' + columns_b );
        console.log( 'window settings: layout is ' + window.envira_gallery_layout + ' and columns is ' + window.envira_gallery_columns );
        <?php endif; ?>

        if ( layout_b !== window.envira_gallery_layout && layout_b !== 'automatic' ) {
            $('.fl-builder-settings').find('select[name=gallery_columns]').val( columns_g );
        } else if ( layout_b !== window.envira_gallery_layout && layout_b === 'automatic' ) {
            $('.fl-builder-settings').find('select[name=gallery_columns]').val( '' );
        }

        window.envira_gallery_layout = layout_b;
        window.envira_gallery_columns = columns_b;

    }


});