<?php
/**
 * Global Functions
 *
 * @package Envira Proofing
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

add_filter( 'envira_gallery_custom_gallery_data_by_beaverbuilder', 'envira_beaverbuilder_update_gallery_data', 10, 4 );

/**
 * Intercept custom values in the shortcode using the dynamic filter 'envira_gallery_custom_gallery_data_by_' in Envira Core Shortcode function.
 *
 * @since 1.1.0
 *
 * @param array $gallery_data Gallery data.
 * @param array $atts Attributes.
 * @param array $post WP post.
 * @param array $gallery_id Gallery ID.
 */
function envira_beaverbuilder_update_gallery_data( $gallery_data, $atts, $post, $gallery_id ) {

	if ( ! isset( $atts['type'] ) || 'beaverbuilder' !== $atts['type'] ) {
		return $gallery_data;
	}
	if ( isset( $atts['columns'] ) && ! empty( $atts['columns'] ) ) {
		$gallery_data['config']['columns'] = intval( $atts['columns'] );
	}
	if ( isset( $atts['layout'] ) && ! empty( $atts['layout'] ) ) {
		$gallery_data['config']['layout'] = esc_html( $atts['layout'] );
	}
	if ( isset( $atts['lightbox_enabled'] ) && ! empty( $atts['lightbox_enabled'] ) ) {
		$gallery_data['config']['lightbox_enabled'] = esc_html( $atts['lightbox_enabled'] );
	}
	if ( isset( $atts['lightbox_theme'] ) && ! empty( $atts['lightbox_theme'] ) ) {
		$gallery_data['config']['lightbox_theme'] = ( 0 === esc_html( $atts['lightbox_theme'] ) ) ? 'base_dark' : esc_html( $atts['lightbox_theme'] );
	}
	if ( isset( $atts['isotope'] ) && ! empty( $atts['isotope'] ) ) {
		$gallery_data['config']['isotope'] = esc_html( $atts['isotope'] );
	}

	return $gallery_data;
}
