/**
 * Handles showing and hiding fields conditionally
 */
jQuery( document ).ready(
	function( $ ) {

			// Show/hide elements as necessary when a conditional field is changed
			$( '#envira-gallery-settings input:not([type=hidden]), #envira-gallery-settings select' ).conditions(
				[

				{	// Instagram elements
					conditions: {
						element: '[name="_envira_gallery[instagram_caption]"]',
						type: 'checked',
						operator: 'is'
					},
					actions: {
						if : [
						{
							element: '#envira-config-instagram-caption-limit-box',
							action: 'show'
						}
						],
						else : [
						{
							element: '#envira-config-instagram-caption-limit-box',
							action: 'hide'
						}
						]
					}
				},
				{

					conditions: {
						element: '[name="_envira_gallery[instagram_link]"]',
						type: 'value',
						operator: 'array',
						condition: [
							'instagram_page',
							'instagram_image',
						],
					},
					actions: {
						if: [
							{
								element:
									'#envira-config-instagram-image-size-box',
								action: 'hide',
							},
						],
						else: [
							{
								element:
									'#envira-config-instagram-image-size-box',
								action: 'show',
							},
						],
					},
				},
				{

					conditions: {
						element: '[name="_envira_gallery[instagram_link]"]',
						type: 'value',
						operator: 'array',
						condition: [
							'instagram_page',
							'instagram_image',
						],
					},
					actions: {
						if: [
							{
								element:
									'#envira-config-instagram-link-target-box',
								action: 'show',
							},
						],
						else: [
							{
								element:
									'#envira-config-instagram-link-target-box',
								action: 'hide',
							},
						],
					},
				}

				]
			);

	}
);
