<?php
/**
 * WP List Table Admin Class.
 *
 * @since 1.5.0
 *
 * @package Envira_Gallery
 * @author  Envira Gallery Team <support@enviragallery.com>
 */

namespace Envira\Instagram\Admin;

use Envira\Instagram\Frontend\Shortcode;

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {

	exit;

}

/**
 * WP List Table Admin Class.
 *
 * @since 1.5.0
 *
 * @package Envira_Gallery
 * @author  Envira Gallery Team <support@enviragallery.com>
 */
class Table {

	/**
	 * Holds the stickies.
	 *
	 * @since 1.5.0
	 *
	 * @var string
	 */
	public $stickies = [];

	/**
	 * Primary class constructor.
	 *
	 * @since 1.5.0
	 */
	public function __construct() {

		add_action( 'envira_gallery_custom_column_icon', [ $this, 'custom_icon' ], 10, 2 );
	}

	/**
	 * Displays in instagram icon for custom Envira gallery tables.
	 *
	 * @since 1.5.0
	 * @param array $gallery_data MYSQL.
	 * @param int   $post_id post id.
	 */
	public function custom_icon( $gallery_data = false, $post_id = false ) {

		if ( ! empty( $gallery_data ) && ! empty( $gallery_data['config']['type'] ) && 'instagram' === $gallery_data['config']['type'] ) {

			echo '<img src="' . esc_url( plugins_url( 'assets/images/types/instagram.png', ENVIRA_FILE ) ) . '" width="75" class="envira_instagram_column_ig_icon" />';

		}
	}
}
