<?php
/**
 * Frontend Container class.
 *
 * @since 1.0.0
 *
 * @package Envira_Instagram
 * @author  Envira Team
 */

namespace Envira\Instagram\Frontend;

use Envira\Instagram\Frontend\CronJobs;

/**
 * Frontend Container class.
 *
 * @since 1.0.0
 *
 * @package Envira_Instagram
 * @author  Envira Team
 */
class Frontend_Container {

	/**
	 * Primary class constructor.
	 *
	 * @since 1.0.0
	 */
	public function __construct() {
		$shortcode = Shortcode::get_instance();
	}

	/**
	 * Check Long Term Token.
	 *
	 * @access public
	 * @return void
	 */
	public function check_long_term_token() {
		$cronjobs = new CronJobs();
		$cronjobs->check_long_term_token();
	}

	/**
	 * Activation hook.
	 *
	 * @since  1.6.1
	 *
	 * @param string $username Username of the Instagram account.
	 * @return void
	 */
	public function remove_instagram_data_by_slot_task( $username ) {
		envira_instagram_clear_plaform_data( $username ); // Clear data.
	}
}
