<?php
/**
 * User might have changed wp-content location, so we go through this dance
 *
 * @package Envira_Printing
 **/

if ( ! isset( $_GET['envira_printing_nonce'] ) || ! wp_verify_nonce( sanitize_key( wp_unslash( $_GET['envira_printing_nonce'] ) ), 'envira_printing_page' ) ) {
	wp_die( esc_html__( 'Invalid Nonce', 'envira-printing' ) );
}

$uri_array        = isset( $_SERVER['SCRIPT_FILENAME'] ) ? explode( '/', sanitize_text_field( wp_unslash( $_SERVER['SCRIPT_FILENAME'] ) ) ) : false;
$counter          = 0;
$element_position = 0;
foreach ( $uri_array as $uri_array_element ) {
	if ( 'envira-printing' === $uri_array_element ) {
		$element_position = $counter - 2;
	} else {
		++$counter;
	}
}

$parse_uri = ( ! empty( $uri_array[ $element_position ] ) ) ? explode( $uri_array[ $element_position ], sanitize_text_field( wp_unslash( $_SERVER['SCRIPT_FILENAME'] ) ) ) : '';
$parse_uri = ( ! empty( $parse_uri[0] ) ) ? $parse_uri[0] : '';

$image_url = isset( $_REQUEST['envira_printing_image'] ) ? esc_url_raw( wp_unslash( $_REQUEST['envira_printing_image'] ) ) : false;

if ( false === $image_url ) {
	wp_die();
}
?>

<!DOCTYPE html>
<html lang="en-us" style="height: 97%;">
<head>
	<style>
		img{display: block; height: auto; width: auto; max-width: 100%; max-height: 100%; display: block; margin: 0 auto;}
	</style>
</head>
<body style="height: 100%;">
	<img src="<?php echo esc_url_raw( $image_url ); ?>" />
	<script type="text/javascript">
		window.print();
	</script>
</body>
</html>
