<?php
/**
 * Posttype menu class.
 *
 * @since 1.0.0
 *
 * @package Envira_Proofing
 * @author  Envira Team
 */

namespace Envira\Proofing\Admin;

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Posttype admin class.
 *
 * @since 1.7.0
 *
 * @package Envira_Gallery
 * @author  Envira Gallery Team <support@enviragallery.com>
 */
class Menus {

	/**
	 * Primary class constructor.
	 *
	 * @since 1.7.0
	 */
	public function __construct() {

		add_action( 'admin_menu', [ $this, 'menu_create' ] );
	}

	/**
	 * Creates the menu page.
	 *
	 * @since 1.7.0
	 */
	public function menu_create() {

		$active_orders = 2;

		add_menu_page(
			'Orders',
			$active_orders ? sprintf( 'Orders <span class="awaiting-mod">%d</span>', $active_orders ) : 'Orders',
			'manage_options',
			'edit.php?post_type=envira_proof_order',
			'contact_form_page_handler'
		);
	}


	/**
	 * Forces the Envira menu icon width/height for Retina devices.
	 *
	 * @since 1.7.0
	 */
	public function menu_icon() {

		?>
		<style type="text/css">#menu-posts-envira_proof_order .wp-menu-image img { width: 16px; height: 16px; }</style>
		<?php
	}
}
