<?php
/**
 * Admin Container class.
 *
 * @since 1.0.0
 *
 * @package Envira_WooCommerce
 * @author  Envira Team
 */

namespace Envira\WooCommerce\Admin;

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

use Envira\WooCommerce\Admin\Ajax;
use Envira\WooCommerce\Admin\Metaboxes;
use Envira\WooCommerce\Admin\Settings;
use Envira\WooCommerce\Frontend\Common;

/**
 * Admin Container class.
 *
 * @since 1.0.0
 *
 * @package Envira_WooCommerce
 * @author  Envira Team
 */
class Admin_Container {

	/**
	 * __construct function.
	 *
	 * @access public
	 * @return void
	 */
	public function __construct() {

		$common   = new Common();
		$ajax     = new Ajax();
		$metabox  = new Metaboxes();
		$settings = new Settings();
	}
}
