<?php
/**
 * Frontend Container class.
 *
 * @since 1.0.0
 *
 * @package Envira_Videos
 * @author  Envira Team
 */

namespace Envira\WooCommerce\Frontend;

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

use Envira\WooCommerce\Frontend\Common;
use Envira\WooCommerce\Frontend\Ajax;
use Envira\WooCommerce\Frontend\Shortcode;

/**
 * Frontend Container class.
 *
 * @since 1.0.0
 *
 * @package Envira_Videos
 * @author  Envira Team
 */
class Frontend_Container {

	/**
	 * Primary class constructor.
	 *
	 * @since 1.0.0
	 */
	public function __construct() {

		$common    = new Common();
		$shortcode = new Shortcode();
		$ajax      = new Ajax();
	}
}
